#include <stdio.h>
#include <string.h>
#include <ctype.h>
main(argc,argv)
int argc;
char *argv[];
{
	static FILE *fdi;		/* The DLG file stream */
	static char buf[81];		/* Lines in Dlg File   */
	static char tmp[512];		/* temp space	       */
	static int ii,jj,kk,ll;		/* Index Variable      */
	static int w,z; 		/* x and y positions   */
	static int nodes;		/* Number of Nodes     */
	static int areas;		/* Number of Areas     */
	static int lines;		/* Number of Lines     */
	static int coord_pairs;		/* Line coord pairs    */
	static char *st;		/* Status	       */
	static char *pp,*qq;		/* Pointers to DLG     */
	static char layer [25];
	static int ls;
	static double integ, dv;
	static double x1,y1;		/* x and y coords      */

	FILE * fopen();
	double strtod();
	double atof();

	if (argc < 2)
	{
		fprintf(stderr,"Usage: dlg2acad <dlg file name> > outputfile\n");
		exit(1);
	}

	/* Do not delete the following, por favor */

	fprintf (stderr, "\n\nDLG to DXF Converter\n");
	fprintf (stderr, "Converts Nodes and Lines\n");
	fprintf (stderr, "Mentor Software, Inc.\n");
	fprintf (stderr, "Copyright (c) 1989, All Rights Reserved\n");
	fprintf (stderr, "Distribute Widely Free of Charge.\n");
	fprintf (stderr, "Call to check out our commercial package.  It\n");
	fprintf (stderr, "has considerably more features.  1-800-234-UNIX\n");
	fprintf (stderr, "-----------------------------------------------\n");

	/* Got to do our own calculations.  Numbers in CD-ROM DLG files are
	   simply not in the right place.  */

	fdi = fopen(argv[1],"r");

	if (argc == 3)
		strcpy (layer, argv[2]);
	else
		strcpy (layer, "LINE");

	for (ii=0; ii < 14; ii++) 
		fgets(buf,81,fdi);

	nodes = lines = areas = 0;

	/* The following loop scans the code to count the
	   number of node, area, and line records.  This is 
	   done in case the category record is incorrect.  
	   The 1:2,000,000 scale files on optical disk are
	   the only case where this occasionally happens.
	   In politically correct DLG files, we could read the
	   category record directly.  However, to increase
	   the odds of success, we do the following */

	while(fgets(buf,81,fdi) != NULL)
	{
		switch(buf[0])
		{
			case 'N':
				nodes++;
				break;
			case 'A':
				areas++;
				break;
			case 'L':
				lines++;
		}
	}

	fclose(fdi);

	fprintf(stderr,"Processing %d nodes\n",nodes);

	fdi = fopen(argv[1],"r");

	/* Skip header junk for now */

	for (ii=0; ii < 15; ii++) 
		fgets(buf,81,fdi);

	puthdr(layer);		/* Initialize a new DXF file */

	/* Do the nodes.  All we want to do is break out the 
	   node location and dump it on the layer NODE. */

	for (ii=0; ii < nodes; ii++)
	{
		st = fgets(buf,81,fdi);
		if (st == NULL) break;

		while(buf[0] != 'N')
		{
			st=fgets(buf,81,fdi);
			if (st == NULL) break;
		}

		if (buf[0] == 'N')
		{
			pp = &buf[6];
			while (isspace(*pp)) pp++;
			if (pp != NULL)
			{
				qq = pp;
				pp = strchr (pp,' ');
				*pp = '\0';
				x1 = atof (qq);
				pp++;
				while (isspace (*pp)) pp++;
				qq = pp;
				pp = strchr (pp,' ');
				*pp = '\0';
				if (qq != NULL)
				{
					y1 = atof (qq);
					fprintf (stderr, "Processing Node %d\r",ii+1);
					fflush (stderr);
					printf ("0\n");
					printf ("POINT\n");
					printf ("8\n");
					printf ("NODE\n");
					printf ("10\n");
					printf ("%lf\n",x1);
					printf ("20\n");
					printf ("%lf\n",y1);
				}
			}
		}
	}

	if (st == NULL)
	{
		fprintf(stderr,"Unexpected end of file\n");
		exit(1);
	}

	fgets(buf,81,fdi);		/* Get rid of extra line */

	fprintf(stderr,"Processing %d areas\n",areas);

	/* Do the areas */
	if ((st != NULL) && (areas > 0 ))
	{
		for (ii=0; ii < areas; ii++)
		{
			st = fgets(buf,81,fdi);
			if (st == NULL) break;
			st = fgets(buf,81,fdi);
			if (st == NULL) break;
		}
	}

	/* Do the lines.  What we care about is stored here and only
	   here. */

	for (ii=0; ii < lines; ii++)
	{

		w = 1;
		z = 13;
		coord_pairs = 0;

		while((st != NULL) && buf[0] != 'L')
		{
			st = fgets(buf,81,fdi);
			if (st == NULL) break;
		}
				
		if (st == NULL)
		{
			/* For some reason the file is fripsed up */

			fprintf(stderr,"Unexpected End of File (lines)\n");
			exit(1);
		}
	

		strncpy(tmp,&buf[42],6);
		tmp[6] = '\0';
		coord_pairs = atoi(tmp);

		fprintf(stderr,"Line: %d of %d Coordinate pair %d \r",
			ii+1,lines,coord_pairs);

		if (coord_pairs)
		{
			/* Assume that there are three pairs on 
			   each line.  We can figure the total 
			   number of lines and partial lines that
			   we have to read for this line segment */

			dv = (double) (coord_pairs / 3.0);

			jj = (int) dv;
			integ = dv - jj;
	
			/* There has to be at least one line of data,
			   so we round up no matter what */

			if (integ > 0.0 && integ < 1.0)
			{
				ls = ((int) dv) + 1;
			}
			else
				ls = (int) dv;
		
			/* Begin a polyline */

			printf(" 0\n");
			printf("POLYLINE\n");
			printf(" 8\n");
			printf("%s\n",layer);
			printf(" 66\n");
			printf(" 1\n");
		

			for (jj=0; jj < ls ; jj++)
			{
				st = fgets(buf,81,fdi);
				if (st == NULL) break;

				if (coord_pairs >= 3)
				{
					ll = 3;
					coord_pairs = coord_pairs - 3;
				}
				else
					ll = coord_pairs;

				/* For each coordinate pair */

				for (kk=0; kk < ll; kk++)
				{
					strncpy(tmp,&buf[w],10);
					tmp[10] = '\0';
					x1 = strtod(tmp,(char **) NULL);
				
					strncpy(tmp,&buf[z],10);
					tmp[10] = '\0';
					y1 = strtod(tmp,(char **) NULL);
				
					/* Each point is a vertex
					   in a polyline */

					printf(" 0\n");
					printf("VERTEX\n");
					printf(" 8\n");
					printf("%s\n",layer);
					printf(" 10\n");
					printf(" %lf\n",x1);
					printf("20\n");
					printf(" %lf\n",y1);
					z += 24;
					w += 24;
				}
				w = 1;		/* x Position in line */
				z = 13;		/* y Position in line */

			}	
			/* Do this after each line segment is defined */

			printf(" 0\n");	
			printf("SEQEND\n");
			printf(" 8\n");
			printf("%s\n",layer);
		
		}

	}
	/* Terminate the DXF file */
	printf(" 0\n");
	printf("ENDSEC\n");
	printf(" 0\n");
	printf("EOF\n");
	fprintf(stderr,"\n");
	fclose(fdi);
}
